/*
ṩʾΪ˲һ߽һԣ
ȫıʵ˲ӦӦóվʹøʾ롣
ڳʾԤ;ʹɵżȻ̷ʧ
ӢʱƼ޹˾еκΡ
*/

#include "EOSApp.h"

/*
	ҳӳƽڴΪ 4K СҳÿҳӦһ
	ҳţPFN: Page Frame Numberҳ 0x0-0x0FFF Ӧ
	 PFN Ϊ 00x1000-0x1FFF Ӧ PFN Ϊ 1ơ
	ԣ PFN  12 λԻҳĻַ
	
	CR3 Ĵ 20 λбҳĿ¼Page Directory
	ҳš 12 λδá
	 
	 	   31                    12 11         0
	       +-----------------------+------------+
	   CR3 | PFN of Page Direcotry |  Reserved  |
	       +-----------------------+------------+
*/

#define CR3_SHIFT	12	// CR3 Ĵֵ 12 λҳĿ¼ҳ

/*
	ҳӳеҳĿ¼ҳڽ̵ 4G ַռе
	λͼ
	
					   ̵ 4G ַռ
			----------+-----------------------+
			0x00000000|                       |
					  |                       |
					  |                       |
			 ûַ |                       |
			   ռ   |                       |
			  2G|                       |
					  |                       |
					  |                       |
					  |                       |
					  |                       |
			----------+-----------------------+
			0x80000000|                       |
					  +-----------------------+------------
					  |                       |0xC0000000
					  |                       |
			 ں˵ַ |                       |
			   ռ   +-----------------------+ 1024 ҳռô
			  2G|  һҳĿ¼ռô   | 0xC0000000  4M
					  |  0xC0300000  4K | 
					  +-----------------------+
					  |                       |
					  +-----------------------+------------
			0xFFFFFFFF|                       |
			----------+-----------------------+
*/

#define PDE_BASE		((ULONG_PTR)0xC0300000)		// ҳĿ¼ַռĻַ
#define PTE_BASE		((ULONG_PTR)0xC0000000)		// ҳַռĻַ

#define PTE_SIZE		0x4		// ҳĿ¼ҳ 4 ֽ
#define PTE_PER_TABLE	0x400	// ҳĿ¼ 1024  PDEҳ 1024  PTE
#define PAGE_SIZE 		0x1000	// ҳҳĿ¼ҳĴС 4096 ֽ

#define PDI_SHIFT 		22		// PDE ı 22 λַĸ 10 λ
#define PTI_SHIFT 		12		// PTE ı 12 λַ 22-12 λ

/*
	ҳĿ¼PDE: Page Directory EntryҳPTE: Page Table Entry
	 4 ֽڣλֻгóĵģĹܿԲοͼ

					31                   12 11       1 0
					+----------------------+----------+-+
			PDE/PTE |         PFN          |          |P| 
					+----------------------+----------+-+
	        
	 0 λΪ 0 ʱʾЧΪ 1 ʱʾЧ 20 λ PDE/PTE ӳ
	ҳš
*/
typedef struct _MMPTE_HARDWARE
{
	ULONG Valid : 1;			// λ		0
	ULONG DoNotCare : 11;		// Щλ	1-11
	ULONG PageFrameNumber : 20;	// ҳ		12-31
}MMPTE_HARDWARE, *PMMPTE_HARDWARE;

ULONG getcr3();		// ڻļʵֵĺʹ汻á


int main(int argc, char* argv[])
{
	//
	//  EOS ӦóǰҪرע⣺
	//
	// 1ҪڵӦóʱܹԽں˲ʾӦԴ룬
	//    ʹ EOS Ŀȫ汾 SDK ļУȻ
	//    ʹôļиӦóĿе SDK ļУ EOS
	//    Ŀڴϵλòܸı䡣
	//
	
	ULONG PfnOfPageDirectory;
	ULONG PageTotal = 0;
	ULONG IndexOfDirEntry;
	ULONG IndexOfTableEntry;
	PMMPTE_HARDWARE pPde;
	PMMPTE_HARDWARE pPte;
	ULONG_PTR PageTableBase;
	ULONG_PTR VirtualBase;
	
	const char* OutputFormat = NULL;

	// Sleep(10000);	// ȴ 10 

	__asm("cli");	// ж

	//
	//  CR3 ҳĿ¼ҳ
	//
	OutputFormat = "\nCR3->0x%X\n";
	PfnOfPageDirectory = (getcr3() >> CR3_SHIFT);
	printf(OutputFormat, PfnOfPageDirectory);

	//
	// һѭҳĿ¼е PDE
	//
	for(IndexOfDirEntry = 0; IndexOfDirEntry < PTE_PER_TABLE; IndexOfDirEntry++)
	{
		pPde = (PMMPTE_HARDWARE)(PDE_BASE + IndexOfDirEntry * PTE_SIZE);

		//
		// Ч PDE
		//
		if(!pPde->Valid)
			continue;
		
		//
		//  PDE Ϣʽ£
		// PDE:  (ӳ 4M ַĻַ)->ӳҳҳ
		//
		OutputFormat = "PDE: 0x%X (0x%X)->0x%X\n";
		VirtualBase = (IndexOfDirEntry << PDI_SHIFT);
		printf(OutputFormat, IndexOfDirEntry, VirtualBase, pPde->PageFrameNumber);
		
		//
		//  PDE ıżӳҳַĻַ
		//
		PageTableBase = PTE_BASE + IndexOfDirEntry * PAGE_SIZE;
		
		//
		// ڶѭҳе PTE
		//
		for(IndexOfTableEntry = 0; IndexOfTableEntry < PTE_PER_TABLE; IndexOfTableEntry++)
		{
			pPte = (PMMPTE_HARDWARE)(PageTableBase + IndexOfTableEntry * PTE_SIZE);
			
			//
			// Ч PTE
			//
			if(!pPte->Valid)
				continue;
			
			//
			//  PTE Ϣʽ£
			// PTE:  (ӳ 4K ַĻַ)->ӳҳҳ
			//
			OutputFormat = "\t\tPTE: 0x%X (0x%X)->0x%X\n";
			VirtualBase = (IndexOfDirEntry << PDI_SHIFT) | (IndexOfTableEntry << PTI_SHIFT);
			printf(OutputFormat, IndexOfTableEntry, VirtualBase, pPte->PageFrameNumber);
			
			//
			// ͳռõҳ
			//
			PageTotal++;
		} // ڶѭ
	} // һѭ
	
	//
	// ռõҳڴ
	//
	OutputFormat = "\nPhysical Page Total: %d\n";
	printf(OutputFormat, PageTotal);
	OutputFormat = "Physical Memory Total: %d\n\n";
	printf(OutputFormat, PageTotal * PAGE_SIZE);
	
	__asm("sti");	// ж
	
	// Sleep(60000);	// ȴ 60 

	return 0;
}
